﻿Imports Windows.ApplicationModel
Imports Windows.ApplicationModel.Activation
Imports Windows.UI.Xaml
Imports Windows.UI.Xaml.Controls

Namespace SimpleMemoryLeak
	Friend NotInheritable Partial Class App
		Inherits Application
		Public Sub New()
			InitializeComponent()
			AddHandler Suspending, AddressOf OnSuspending
		End Sub

		Protected Overrides Sub OnLaunched(ByVal e As LaunchActivatedEventArgs)
			Dim rootFrame As Frame = TryCast(Window.Current.Content, Frame)
			If rootFrame Is Nothing Then
				rootFrame = New Frame()
				If e.PreviousExecutionState = ApplicationExecutionState.Terminated Then
				End If
				Window.Current.Content = rootFrame
			End If

			If e.PrelaunchActivated = False Then
				If rootFrame.Content Is Nothing Then
					rootFrame.Navigate(GetType(MainPage), e.Arguments)
				End If
				Window.Current.Activate()
			End If
		End Sub

		Private Sub OnSuspending(ByVal sender As Object, ByVal e As SuspendingEventArgs)
            Dim deferral As SuspendingDeferral = e.SuspendingOperation.GetDeferral()
            deferral.Complete()
		End Sub
	End Class
End Namespace
