﻿Imports System
Imports System.Collections.Generic
Imports Windows.UI.Xaml
Imports Windows.UI.Xaml.Controls


Namespace SimpleMemoryLeak
	Public NotInheritable Partial Class MainPage
		Inherits Page
		Public Sub New()
			InitializeComponent()
		End Sub

		Private Sub simulateLeak_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
            SimulateLeakMethod()
        End Sub

		Private Sub cleanUp_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
            CleanUpMethod()
        End Sub

		Private buffer As New List(Of Byte())()

        Private Sub SimulateLeakMethod()
            buffer.Add(New Byte(10 * 1024 * 1024 - 1) {})
        End Sub

        Private Sub CleanUpMethod()
            buffer.Clear()
            GC.Collect()
            GC.WaitForPendingFinalizers()
            GC.Collect()
            GC.WaitForPendingFinalizers()
        End Sub

    End Class
End Namespace
